## onnxruntime 1.21.0+dfsg

=== requirements.txt ===
coloredlogs
flatbuffers
numpy >= 1.21.6
packaging
protobuf
sympy
