=== cmake/tensorboard/CMakeLists.txt ===
add_subdirectory(compat/proto)
