=== onnxruntime/test/python/requirements.txt ===
onnx==1.17.0
pytest
