=== onnxruntime/python/tools/tensorrt/perf/requirements.txt ===
onnxconverter-common
onnxmltools
pandas
coloredlogs
