=== debian/changelog ===
onnxruntime (1.21.0+dfsg-2~mx25+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 27 Dec 2025 10:09:38 -0800

onnxruntime (1.21.0+dfsg-2) unstable; urgency=medium

  [ Dylan Aïssi ]
  * Move providers into their own package to avoid conflicts (Closes: #1098349)
  * Cherry-pick upstream patches:
    - fixing compilation with gcc-15 (Closes: #1097506)
    - fixing transpose store op for LoongArch (Closes: #1105821)

  [ YOKOTA Hiroshi ]
  * Enable i386 on CI build
  * Add SSE2 requirement flag to control file
  * Enable SSE2 for Debian i386 platform (Closes: #1110690)

 -- Dylan Aïssi <daissi@debian.org>  Mon, 15 Sep 2025 14:26:46 +0200

onnxruntime (1.21.0+dfsg-1) unstable; urgency=medium

  * Upload to unstable.
  * d/patches: update set-soversion.patch to use SOVERSION in the generation of
    linker scripts (so that ABIs are stable across patch releases).
  * Update symbol control file for libonnxruntime1.21.

 -- Shengqi Chen <harry@debian.org>  Thu, 13 Mar 2025 23:28:54 +0800

onnxruntime (1.21.0+dfsg-1~exp2) experimental; urgency=medium

  * d/tests: add test-name feature to all stanza
  * d/control:
    + bump std-ver to 4.7.2 (no changes required)
    + disable test-related B-D since tests are not compiled
  * d/patches:
    + do not require unused packages to be found in cmake
    + simply system-date-and-mp11.patch

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Mar 2025 13:03:10 +0800

onnxruntime (1.21.0+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 1.21.0+dfsg
    + change SONAME to libonnxruntime1.21
    + enable dlpack and add patch to use libdlpack from system
  * d/patches:
    + refresh all existing patches, remove unused patch
    + set SONAME to MAJOR.MINOR to avoid needless transitions
    + backport gcc-14 compilation fix from upstream
    + disable downloading in system-re2.patch

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Mar 2025 00:46:59 +0800
