=== tools/ci_build/requirements/transformers-test/requirements.txt ===
# packages used by transformers python unittest
packaging
# protobuf and numpy is same as tools/ci_build/github/linux/docker/scripts/manylinux/requirements.txt
protobuf==4.25.1
numpy==2.2.6
torch>=2.6.0
coloredlogs==15.0
transformers==4.52.1
parameterized>=0.8.1
sentencepiece
psutil
einops
onnxscript==0.3.2
