=== tools/ci_build/github/linux/python/requirements.txt ===
numpy==2.2.6
mypy
pytest
setuptools>=68.2.2
wheel
onnx==1.18.0
protobuf==4.25.1
sympy==1.14
flatbuffers
psutil
onnxscript==0.3.2
jinja2
markupsafe
