=== tools/ci_build/github/linux/docker/scripts/requirements.txt ===
cerberus
numpy==2.2.6
mypy
pytest
setuptools==78.1.1
wheel==0.45.1
onnx==1.18.0
argparse
sympy==1.14
flatbuffers
protobuf==4.25.1
packaging
