=== debian/changelog ===
onnxruntime (1.23.1+dfsg-1) experimental; urgency=medium

  [ Shengqi Chen ]
  * New upstream version 1.23.1+dfsg.
  * d/patches: refresh and remove outdated patches.
  * Bump SONAME to libonnxruntime1.23.

  [ Dylan Aïssi ]
  * Add patch fixing maybe-uninitialized and range-loop-construct warnings
  * d/control: bump B-D version of onnx

 -- Dylan Aïssi <daissi@debian.org>  Mon, 12 Jan 2026 22:52:07 +0100

onnxruntime (1.21.0+dfsg-3) unstable; urgency=medium

  [ Kentaro Hayashi ]
  * Use d/watch 5

  [ Dylan Aïssi ]
  * d/watch: use Github template
  * Don't treat uninitialized warnings as errors for now (Closes: #1117355)
  * Build ONNX Runtime with -O3 like binaries provided upstream
  * Build-Deps on python3* rather than python3-all* (Closes: #1119803)
  * Add debian/gbp.conf
  * debian/salsa-ci: disable arm64 and remove reference to reprotest

 -- Dylan Aïssi <daissi@debian.org>  Mon, 05 Jan 2026 21:06:37 +0100
